dnl AM_PATH_ORBITCPP([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND [, MODULES]]]])
dnl Test for ORBit-C++, and define ORBITCPP_CFLAGS, ORBITCPP_LIBS, ORBITCPP_NAME_CFLAGS, 
dnl ORBITCPP_NAME_LIBS
dnl
AC_DEFUN(AM_PATH_ORBITCPP,
[dnl 
dnl Get the cflags and libraries from the orbitcpp-config script
dnl
AC_ARG_WITH(orbitcpp-prefix,[  --with-orbitcpp-prefix=PFX   Prefix where ORBITCPP is installed (optional)],
            orbitcpp_config_prefix="$withval", orbitcpp_config_prefix="")
AC_ARG_WITH(orbitcpp-exec-prefix,[  --with-orbitcpp-exec-prefix=PFX Exec prefix where ORBITCPP is installed (optional)],
            orbitcpp_config_exec_prefix="$withval", orbitcpp_config_exec_prefix="")

  for module in . $4
  do
      case "$module" in
         server) 
             orbitcpp_config_args="$orbitcpp_config_args server"
	 ;;
         client) 
             orbitcpp_config_args="$orbitcpp_config_args client"
         ;;
      esac
  done
  if test x$orbitcpp_config_args = x ; then
	orbitcpp_config_args=server
  fi

  if test x$orbitcpp_config_exec_prefix != x ; then
     orbitcpp_config_args="$orbitcpp_config_args --exec-prefix=$orbitcpp_config_exec_prefix"
     if test x${ORBITCPP_CONFIG+set} != xset ; then
        ORBITCPP_CONFIG=$orbitcpp_config_exec_prefix/bin/orbitcpp-config
     fi
  fi
  if test x$orbitcpp_config_prefix != x ; then
     orbitcpp_config_args="$orbitcpp_config_args --prefix=$orbitcpp_config_prefix"
     if test x${ORBITCPP_CONFIG+set} != xset ; then
        ORBITCPP_CONFIG=$orbitcpp_config_prefix/bin/orbitcpp-config
     fi
  fi

  AC_PATH_PROG(ORBITCPP_CONFIG, orbitcpp-config, no)
  min_orbitcpp_version=ifelse([$1], , 0.28.0, $1)
  AC_MSG_CHECKING(for ORBit-C++ - version >= $min_orbitcpp_version)
  no_orbitcpp=""
  if test "$ORBITCPP_CONFIG" = "no" ; then
    no_orbitcpp=yes
  else
    ORBITCPP_CFLAGS=`$ORBITCPP_CONFIG $orbitcpp_config_args --cflags`
    ORBITCPP_LIBS=`$ORBITCPP_CONFIG $orbitcpp_config_args --libs`
    orbitcpp_config_major_version=`$ORBITCPP_CONFIG $orbitcpp_config_args --version | \
	   sed -e 's,[[^0-9.]],,g' -e 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    orbitcpp_config_minor_version=`$ORBITCPP_CONFIG $orbitcpp_config_args --version | \
	   sed -e 's,[[^0-9.]],,g' -e 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    orbitcpp_config_micro_version=`$ORBITCPP_CONFIG $orbitcpp_config_args --version | \
	   sed -e 's,[[^0-9.]],,g' -e 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
  fi
  if test "x$no_orbitcpp" = x ; then
     AC_MSG_RESULT(yes)
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$ORBITCPP_CONFIG" = "no" ; then
       echo "*** The orbitcpp-config script installed by ORBIT-C++ could not be found"
       echo "*** If ORBit-C++ was installed in PREFIX, make sure PREFIX/bin is in"
       echo "*** your path, or set the ORBITCPP_CONFIG environment variable to the"
       echo "*** full path to orbitcpp-config."
     fi
     ORBITCPP_CFLAGS=""
     ORBITCPP_LIBS=""
     ifelse([$3], , :, [$3])
  fi

  if test "x$no_orbitcpp" = "xyes" ; then 
	exit 1
  fi

  AC_PATH_PROG(ORBIT_IDL, orbit-idl, ifelse([$3], , :, [$3]))
  ORBITCPP_NAME_CFLAGS=`$ORBITCPP_CONFIG --use-service=name --cflags client`
  ORBITCPP_NAME_LIBS=`$ORBITCPP_CONFIG --use-service=name --libs client`
  AC_SUBST(ORBITCPP_CFLAGS)
  AC_SUBST(ORBITCPP_LIBS)
  AC_SUBST(ORBIT_IDL)
  AC_SUBST(ORBITCPP_NAME_CFLAGS)
  AC_SUBST(ORBITCPP_NAME_LIBS)
])
